;
;	Digitlis video- s hanglejtszs stream-elssel VT-DOS-ra
;
;
;

VIDTYPE_FORM	.equ	008h		; formzott kp tpuskdja
VIDTYPE_FMASK	.equ	0FCh		; maszk a formtumkdhoz
VIDTYPE_COLMASK	.equ	003h		; maszk a sznkdokhoz

;
;
;	Mozimd belltsa (csak fekete BORDER-rel mkdik minden esetben)
;	in:  H - megjelentend karakterek szma soronknt (1..64)
;	     L - megjelentend karaktersorok szma (1..64)
;	out: -
;
setmovi:ld	a,001h			; R1: megjelentett karakterek szma soronknt
	out	(070h),a		; CRTC cm regiszter
	ld	a,h
	out	(071h),a		; CRTC adat regiszter
	ld	a,002h			; R2: vzszintes szinkronpozci
	out	(070h),a		; CRTC cm regiszter
	ld	a,040h			; A reg.= soronknti karakterszm alaprtke
	sub	h
	srl	a			; A reg.= eltrs / 2
	ld	h,a
	ld	a,04Bh			; A reg.= vzszintes szinkronpozci alaprtke
	sub	h			; pozci korriglsa kisebb kpszlessg esetre
	out	(071h),a		; CRTC adat regiszter
	ld	a,006h			; R6: megjelentett karaktersorok szma
	out	(070h),a		; CRTC cm regiszter
	ld	a,l
	out	(071h),a		; CRTC adat regiszter
	ld	a,007h			; R7: fggleges szinkron pozci
	out	(070h),a
	ld	a,03Ch			; A reg.= megjelentett karaktersorok alaprtke
	sub	l
	srl	a			; A reg.= eltrs / 2
	ld	l,a
	ld	a,042h			; A reg.= fggleges szinkronpozci alaprtke
	sub	l			; pozci korriglsa kisebb kpmagassg esetre
setmov0:out	(071h),a
resmad:	ld	hl,0000h
setmad:	ld	a,00Ch			; R12: kpkezd memriacm H
	out	(070h),a
	ld	a,h
	out	(071h),a
	ld	a,00Dh			; R13: kpkezd memriacm L
	out	(070h),a
	ld	a,l
	out	(071h),a
	ld	de,(curpos)		; kurzorpozci belltsa az utols karakterre
	add	hl,de
	ld	a,00Eh
	out	(070h),a		; CRTC R14: kurzorpozci H
	ld	a,h
	out	(071h),a
	ld	a,00Fh
	out	(070h),a		; CRTC R15: kurzorpozci L
	ld	a,l
	out	(071h),a
	ret

;
;
;	Mozimd kikapcsolsa
;	in:  -
;	out: -
;
resmovi:ld	a,000h			; 2-szn md belltsa, egyben a hang lekapcsolsa
	out	(006h),a
	out	(060h),a		; 0. s 1. palettaregiszter trlse
	out	(061h),a
	ld	hl,CRTCinit		; HL= CRTC regiszterekbe belltand rtkek tblzatcme
	ld	b,010h			; 16 regisztert programoz fel
	ld	c,071h			; kpernyvezrl (CRTC) adatregiszter I/O cme
resmov0:ld	a,b			; a magasabb regisztercmekkel kezdi
	dec	a
	out	(070h),a		; belltand bels CRTC regiszter cme
	outi				; adatregiszterbe a tblzatbl olvasott rtk
	jr	nz,resmov0		; ismtls, amg a B-ben adott szm regisztert be nem lltotta
	ret

;
;	CRTC regiszterekbe rand rtkek
;	(a magasabb cm bels regiszterekbe rand adatok vannak elbb)
;
CRTCinit:
	.db	0FFh,00Ah,000h,000h,003h,003h,003h,000h
	.db	042h,03Ch,002h,04Dh,032h,04Bh,040h,063h


;
;	Paletta belltsa
;	in:  HL - paletta adatokra mutat
;	out:  A - megrzdik
;	     HL - paletta adatok utn mutat
;
setpal:	ld	b,004h			; B= belltand paletta-regiszterek szma (4)
	ld	c,05Fh			; C= paletta-regiszterek I/O cme -1
setpal0:inc	c			; paletta belltsa
	outi				; regiszter lltsa, B=B-1
	jr	nz,setpal0
	ret

;
;
;	Eredeti megszakts visszalltsa
;
resint:	di				; megszak. tilt
	ld	hl,osint		; HL= eredeti megszak. rutin visszalltand kdrszlete
	ld	de,0038h		; DE= megszak. cme
	ld	bc,0003h		; BC= 3 bjt lesz
	ldir				; bjtok msolsa
	ld	a,(Port5)		; A reg.= Port5 eredeti rtke
	out	(005h),a		; Port5 helyrelltsa
	ld	a,00Ah			; CRTC R10-es regiszterben a kurzor engedlyezse
	out	(070h),a
	ld	a,003h
	out	(071h),a
	ld	a,(ivector)		; megszaktsvektor helyrelltsa
	ld	i,a
	im	2			; 2-es megszaktsi md belltsa
	ld	a,(imode)		; eredeti megszaktsi md flag-je A reg.-be
	or	a
	jr	z,resin0		; ugrs, ha IM2 volt
	im	1			; 1-es megszaktsi md belltsa
resin0:	ei				; megszak. eng.
	ret


;
;
;	Sajt megszakts belltsa
;	in:  -
;	out: BC - megrzdik
;
setint:	push	bc			; frame szm mentse
	ld	a,i
	ld	(ivector),a		; IM2-es megszaktsvektor mentse
	ld	hl,0038h		; HL= az IM1-es megszaktsi rutin terletre mutat
	ld	de,osint		; DE= mentsi terlet cme
	ld	bc,0003h		; BC= 3 bjt lesz
	ldir				; bjtok lementse
	di				; megszak. tilt
	ld	hl,vint			; HL= kiszolgl rutin cme az IM md megllaptshoz
	ld	a,0C3h			; A reg.= JP XXXX kdja
	ld	(0038h),a		; megszaktsrutin els bjtjnak trsa
	ld	(0039h),hl		; ugrutasts clcm bersa
	ld	hl,0000h
	ld	(playadr),hl		; szmll nullzsa
	ei				; megszak. eng.
	halt				; legalbb egy megszakts megvrsa
	ld	a,(playadr)
	ld	(imode),a		; eredeti megszaktsi md elmentse: 0-> IM2  !0-> IM1
	pop	bc			; frame szm vissza
	ld	hl,(nsamples)
	ld	a,h
	or	l
	jr	z,setvid		; ugrs, ha nincsenek hangmintk


;
;
;	Hang megszakts engedlyezse, lejtszs alaphelyzetbe lltsa
;
setsnd:	di				; megszak. tilt	
	ld	hl,(sndaddr)		; HL= hangmintk kezdete az els frame pufferen bell
	ld	(playadr),hl		; adatok kezdete
	ld	hl,00200h		; H = az aktulis adatbjtban htralv mintk szma
	ld	(sample),hl
	ld	hl,(pitch)		; HL= lejtszsi sebessg PITCH rtke
	ld	a,l
	out	(004h),a		; PITCH als 8 bit belltsa
	ld	a,(Port5)		; A= Port5 tkrkpe
	and	0C0h			; fels 2 bit megtartsa
	or	h			; j PITCH rtk az als 4 bitbe
	or	020h			; hang IT engedlyezse
	out	(005h),a		; kirs a portra
	ld	a,00Ah
	out	(070h),a		; CRTC bels regiszternek kivlasztsa (R10)
	ld	a,003h
	or	020h			; kurzor tiltsa
	out	(071h),a		; bels regiszter j rtknek bersa
	ld	hl,sndint		; HL= belltand megszak. kiszolgl kezd cme
	ld	a,0C3h			; A reg.= JP XXXX kdja
	ld	(0038h),a		; megszaktsrutin els bjtjnak trsa
	ld	(0039h),hl		; ugrutasts clcm bersa
	ld	(israddr),hl		; cm a vltozba is
	im	1			; 1-es megszaktsi md belltsa
	ei				; megszak. eng.
	ret


;
;
;	Sajt megszakts-kiszolgl rutin hanglejtszshoz
;
sndint:	out	(007h),a		; kurzor/hang megszak. krs trlse
	push	af
	push	hl
	ld	hl,(playadr)		; HL-ben az aktulisan jtszott mintabjt cme
	ld	a,(hl)			; kzvetlen mintabjt A reg.-be
	out	(006h),a		; amplitd bersa a portba
	inc	l			; cm alsbjt nvelse
	jr	z,sndin1		; ugrs, ha tfordult az als bjt
	ld	(playadr),hl
sndin0:	pop	hl
	pop	af
	ei				; megszak. eng
	ret				; visszatrs
;
sndin1:	inc	h
	ld	(playadr),hl
	ld	a,(sndend+1)		; hangmintk vgcmnek fels bjtja A reg.-be
	res	5,h
	cp	h
	jp	nc,sndin0		; ugrs, ha mg nem lpte t a frame utols szektort
	ld	hl,vint			; HL= j kiszolgl rutin cme
	ld	(0039h),hl		; ugrutasts clcm bersa
	jp	sndin0


;
;	Video megszakts engedlyezse
;
setvid:	di
	ld	hl,(sndaddr)		; hangadatok kezdete, csak az idmrs miatt
	ld	(playadr),hl		; hangadatok lejtszsi cmnek belltsa
	ld	hl,vint			; HL= kiszolgl rutin cme
	ld	a,0C3h			; A reg.= JP XXXX kdja
	ld	(0038h),a		; megszaktsrutin els bjtjnak trsa
	ld	(0039h),hl		; ugrutasts clcm bersa
	ld	(israddr),hl		; cm a vltozba is
	ld	a,(Port5)		; A= Port5 tkrkpe
	res	5,a			; hang IT tiltva
	res	4,a			; hangjel is tiltva
	out	(005h),a		; kirs a portra
	ld	a,00Ah
	out	(070h),a		; CRTC R10: kurzor kezd TV sora + kurzor eng.
	ld	a,003h
	out	(071h),a
	ld	a,00Bh
	out	(070h),a		; CRTC R11: kurzor befejez TV sora
	ld	a,003h
	out	(071h),a
	im	1			; 1-es megszaktsi md belltsa
	ei
	halt				; az els nem teljes 20ms-os idkz megvrsa
	ret


;
;	Sajt megszakts-kiszolgl rutin video lejtszshoz
;	in:  -
;	out: -
;
vint:	out	(007h),a		; kurzor/hang megszak. krs trlse
	push	hl
	ld	hl,(playadr)
	inc	hl			; hangadatok lejtszsi cmnek nvelse (az idmrs miatt)
	ld	(playadr),hl
	pop	hl
	ei				; megszak. eng
	ret				; visszatrs


;
;	FISH meghvsa
;	in:   A - FISH funkcikd
;	     BC,DE,HL,IX - paramterek
;	out:  A - hibakd
;	     BC,DE,HL,IX - FISH funkci kimeneti paramterei
;
fk_fish:rst	08h
	ret


;
; 	Hasznlatlan FCB kitltse
;	in:  DE - kitltend FCB elejre mutat
;	     HL - berand 8+3-as fjlnv
;	out: -
;
fk_fcb:	push	hl
	ld	h,d			; HL is az FCB elejre mutat
	ld	l,e
	xor	a
	ld	b,48			; 48 bjt trlse
fk_fcb0:ld	(de),a
	inc	de
	djnz	fk_fcb0
	ld	(hl),0FFh		; hasznlatlan FCB jelzs
	ld	de,0006
	add	hl,de
	ld	(hl),0			; keressi attributum (nem keres ktet azonostt)
	inc	hl
	ld	(hl),0			; 0=aktulis meghajt
	inc	hl
	pop	de			; DE= 8+3 bjtos fjlnv
	ex	de,hl
	ld	bc,11			; 8+3 bjtos fjlnv tmsolsa
	ldir				; a tbbi vltoz nulla
	ret


;	
;	Fjl megnyitsa
;	in:  DE - tvonalstringre mutat
;	     HL - 8+3 (11 karakteres) fjlnvre mutat
;	out:  A - hibakd 
;
fk_open:push	de
	ld	de,FCB_1		; FCB1 kitltse hasznlatlan FCB-knt a megadott nvvel
	call	fk_fcb
	ld	bc,FCB_0		; BC= hely a tallt FCB-nek
	ld	de,FCB_1		; DE= hasznlatlan FCB (aminek megfelel fjlt keres)
	pop	hl			; HL= tvonalnv kezdete
	ld	a,004h			; A = FISH funkci: els keresse
	call	fk_fish			; FISH funkci hvsa
	or	a			; volt hiba?
	ret	nz			; ha igen, vissza a hvhoz
	ld	de,FCB_0		; FCB_0 a tallt meghatrozott FCB
	ld	hl,FCB_1		; FCB_1 a keressi FCB
	ld	a,00Ch			; A = FISH funkci: fjl megnyitsa
	call	fk_fish			; FISH funkci hvsa
	or	a			; ZF belltsa a hibnak megfelelen
	ret


;
;	Fjl olvassa
;	in:  BC - olvasand hossz
;	     IX - tltsi cm
;	out:  A - hibakd
;
fk_read:ld	de,FCB_0		; FCB_0 a megnyitott FCB
	ld	a,00Fh			; A = FISH funkci: olvass fjlbl
	call	fk_fish			; FISH funkci hvsa
	or	a
	ret


;
;	Megnyitott fjl lezrsa
;	in:  -
;	out: A - hibakd
;
fk_close:
	ld	de,FCB_0		; FCB_0 a megnyitott FCB
	ld	a,00Dh			; A = FISH funkci: fjl lezrsa
	call	fk_fish			; FISH funkci hvsa
	ret


;
; 	Vrakozs az aktulis frame vgre majd pufferek vltsa
;	in:   A - kvetkez kppuffer kpkezd cmnek fels bjtja (000h vagy 008h)
;	out:  A - hibakd (az ESC ASCII kdja)
;	     ZF - ZF=0 a Q (kilps) billentyt lenyomtk
;
waitfrm:ld	bc,(nsamples)		; BC= hangmintk szma
	ld	de,(sndaddr)		; DE= hangmintk kezdete az 1. kppufferen bell
	or	a
	jr	nz,wfrm1		; ugrs, ha az 1. kppuffer az aktv
	set	5,d			; DE= hangmintk kezdete a 2.kppufferben
	jr	wfrm1
;
wfrm0:	halt				; frame vgnek kivrsa
	or	a			; CY=0
wfrm1:	ld	hl,(playadr)		; aktulis hang-lejtszsi cm HL-be
	sbc	hl,de			; HL= kvetkez hangminta cme
	sbc	hl,bc
	jr	c,wfrm0			; ugrs, ha mg nem jtszott le minden mintt
	add	hl,bc
	ld	b,h			; lejtszott mintaszm BC-be
	ld	c,l
	ld	h,a			; HL= kpkezd memriacm a kvetkez kppufferhez
	ld	l,000h
	ld	a,020h			; hangadatok kezdetnek tlltsa a msik pufferre
	xor	d
	ld	d,a
	di
	ld	(playadr),de
	ld	de,(israddr)		; DE= belltand megszak. kiszolgl kezd cme
	ld	(0039h),de		; ugrutasts clcm bersa
	ei
	call	setmad
	ld	hl,(vidtimeL)
	add	hl,bc			; szmll nvelse a lejtszott mintaszmmal
	ld	(vidtimeL),hl
	jr	nc,chesc		; ugrs, ha nincs tvitel a fels szra
	ld	hl,(vidtimeH)
	inc	hl			; fels sz nvelse
	ld	(vidtimeH),hl


;
;
;	Q (kilps) billenty llapotnak beolvassa
;	in: -
;	out:  A - ESC karakterkdja vagy 0
;	     ZF - ZF=0 valamelyik vizsgland billentyt lenyomtk
;
chesc:	ld	a,(Port3)		; A reg.= Port3 tkrkpe (billentyzetsor)
	and	0F0h			; fels 4 bit meghagyva
	or	002h			; a 2. sor kivlasztsa	
	out	(003h),a		; sor belltsa a porton
	in	a,(058h)		; kivlasztott billentyzetsor beolvassa
	and	040h			; Q billenty bitjnek megtartsa
	xor	040h			; bit invertlsa
	ret	z			; visszatrs, ha nem aktv, A reg.= 000h
	ld	a,01Bh			; A reg.= ESC karakterkdja
	ret


;
; 	Videofjl fejlcnek feldolgozsa
;	in:  HL - fejlcadatok kezdete
;	out: BC - framek szma (als sz)
;	     DE - eltols az adatblokk kezdethez
;	     HL - megjelentend karakter oszlopok s sorok szma
;	     ZF - ZF=0 -> nem megfelel fjlformtum
;
vidhead:ld	b,003h			; fejlc ellenrzse
	ld	de,vidid
vidhd0:	ld	a,(de)
	cp	(hl)
	ret	nz			; visszatrs, ha nem egyezik a fejlcazonost
	inc	de
	inc	hl
	djnz	vidhd0
	ld	a,(hl)			; kp tpusa
	and	VIDTYPE_COLMASK
	ld	c,a			; VMODE grafikus md: 0-ktszn  1-ngy  2-tizenhat
	call	vidmod
	ld	a,(hl)			; A reg.= kp tpusa
	inc	hl
	call	setpal			; paletta belltsa
	ld	c,a			; C= kp tpusa
	and	VIDTYPE_FMASK
	cp	VIDTYPE_FORM
	ret	nz			; visszatrs, ha nem formzott s nem tmrtetlen
	ld	e,(hl)			; DE= X mret kppontokban
	inc	hl
	ld	d,(hl)
	inc	hl
	srl	d			; DE= X mret / 2
	rr	e
	bit	1,c
	jr	nz,vidhd1		; ugrs, ha 16 szn md
	srl	d			; DE= X mret / 4
	rr	e
	bit	0,c
	jr	nz,vidhd1		; ugrs, ha 4 szn md
	srl	d			; DE= X mret / 8
	rr	e
vidhd1:	ld	d,e			; D= megjelentend karakterek szma soronknt
	ld	e,(hl)			; E= Y mret TV sorokban (als bjt)
	srl	e
	srl	e			; E= megjelentend karaktersorok szma
	push	de
	push	hl
	ld	c,d			; X s Y karaktermretek sszeszorzsa
	ld	b,000h
	ld	d,b
	call	ut_mul
	dec	de
	ld	(curpos),de		; kurzorpozci relatv rtknek mentse
	pop	hl
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	ld	e,(hl)			; DE= eltols az adatblokk kezdethez (most mg nem hasznlt)
	inc	hl
	ld	d,(hl)
	inc	hl
	push	de
	ld	c,(hl)			; BC= framek szma (als sz)
	inc	hl
	ld	b,(hl)
	ld	de,0007h
	add	hl,de
	ld	e,(hl)			; DE= egy frame hossza
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	a,d
	or	e
	jr	nz,vidhd2		; ugrs, ha meg van adva a frame-hossz
	ld	de,02000h		; DE belltsa 8192-re, gy kompatbilis a korbbi vide demval
vidhd2:	ld	(framelen),de		; egy frame hossznak mentse
	ld	e,(hl)			; DE= hangmintk kezdete
	inc	hl
	ld	d,(hl)
	inc	hl
	set	7,d
	ld	(sndaddr),de		; hangmintk kezdcme az 1. kppufferben
	ld	e,(hl)			; DE= egy frame-hez tartoz hangmintk szma bjtban
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	(nsamples),de		; hangmintk szmnak mentse
	push	hl
	ld	hl,(sndaddr)
	add	hl,de
	dec	hl
	ld	(sndend),hl		; hangmintk vgcme az 1. kppufferben
	pop	hl
	ld	de,00006h
	add	hl,de
	ld	e,(hl)			; DE= mintavteli frekvencia PITCH rtke
	inc	hl
	ld	a,(hl)
	and	00Fh
	ld	d,a
	ld	(pitch),de		; PITCH rtk mentse a ksbbi felhasznlshoz
	pop	de
	pop	hl			; HL= megjelentend karakter oszlopok s sorok szma
	xor	a			; ZF=1
	ret


;
;
;	Videofjl lejtszsa
;	in:  HL - 8+3 (11 karakteres) fjlnvre mutat (az aktulis knyvtrban keresi)
;	out:  A - hibakd -> ESC-et nyomtak vagy lemezes hiba trtnt
;
vidplay:ld	de,nullstr		; videofjl megnyitsa
	call	fk_open
	jp	nz,vidpl1		; ugrs, ha hiba volt
;
	ld	ix,puffer		; DE= tltsi cm (fejlc beolvassa) 
	ld	bc,00200h		; BC= beolvasand bjtok (512)
	call	fk_read
	jp	nz,vidpl1		; ugrs, ha hiba volt
	ld	hl,puffer
	call	vidhead
	jp	nz,vidpl1		; ugrs, ha nem megfelel a fjlformtum
	xor	a
	out	(000h),a		; BORDER feketre lltsa (a fggleges szinkron miatt)
	call	setmovi			; kperny mozimdba kapcsolsa
	halt				; vrakozs, amg a TV-n is bell az j szinkron
	halt
	halt
	halt
;
	dec	bc			; frame szm cskkentse
	ld	a,b
	or	c
	jr	z,vidpl1		; ugrs, ha csak egy frame lett volna
	push	bc			; els kt frame beolvassa
	ld	ix,08000h		; IX= tltsi cm
	ld	bc,(framelen)		; BC= beolvasand bjtok
	sla	c
	rl	b
	call	fk_read			; 2 frame-et olvas elsre
	pop	bc
	jp	nz,vidpl1		; ugrs, ha hiba volt
	dec	bc			; frame szm cskkentse
	ld	a,b
	or	c
	jr	z,vidpl1
	call	setint			; sajt megszaktsi rutin belltsa
	ld	hl,0000h
	ld	(vidtimeL),hl		; idmr nullzsa
	ld	(vidtimeH),hl
vidpl0:	push	bc
	ld	a,008h			; a 2. kppufferre fog vltani
	call	waitfrm			; vrakozs, majd a megjelents tvltsa a 2. pufferre
	ld	ix,08000h		; IX= tltsi cm (1. kppuffer) 
	ld	bc,(framelen)		; BC= beolvasand bjtok
	call	z,fk_read		; olvass, ha nem nyomtak ESC-et
	pop	bc
	jp	nz,vidpl1		; ugrs, ha hiba volt
	dec	bc			; frame szm cskkentse
	ld	a,b
	or	c
	jr	z,vidpl1
;
	push	bc
	ld	a,000h			; az 1. kppufferre fog vltani
	call	waitfrm			; vrakozs, majd a megjelents tvltsa az 1. pufferre
	ld	ix,0A000h		; IX= tltsi cm (2. kppuffer) 
	ld	bc,(framelen)		; BC= beolvasand bjtok
	call	z,fk_read		; olvass, ha nem nyomtak ESC-et
	pop	bc
	jp	nz,vidpl1		; ugrs, ha hiba volt
	dec	bc			; frame szm cskkentse
	ld	a,b
	or	c
	jr	nz,vidpl0
vidpl1:	push	af
	call	resint			; megszaktsok helyrelltsa
	call	fk_close
	call	resmovi			; kperny mozimd kikapcsolsa
	halt				; vrakozs, amg a TV-n is bell az j szinkron
	halt
	pop	af
	or	a			; CY=0
	ret


;
;
;	Lejtszs sorn eltelt id kiszmtsa
;	in:   -
;	out:  H - rk
;	      L - percek
;	      D - msodpercek
;	      E - szzadmsodpercek
;
vidtime:ld	de,(nsamples)		; DE= egy frame-re es hangmintk szma
	ld	a,d
	or	e
	jr	z,vidtim0		; ugrs, ha nincsenek hangmintk
	ld	de,(pitch)		; DE= lejtszsi sebessg PITCH rtke
	ld	hl,01000h		; HL= 4096
	or	a
	sbc	hl,de			; HL= 4096 - PITCH
	add	hl,hl			; HL= (4096 - PITCH) * 2
	ld	b,h			; BC= szorz
	ld	c,l
	ld	hl,(vidtimeH)
	ld	de,(vidtimeL)
	call	ut_mul32		; hangmintk szmnak szorzsa a mintavteli peridusidvel
	ld	b,c			; eredmny szorzsa 256-al
	ld	c,h
	ld	h,l
	ld	l,d
	ld	d,e
	ld	e,000h			; BC:HL:DE = hangmintk szma * ((4096 - PITCH) * 512 * 10^-8 sec)
	push	ix
	push	de
	pop	ix			; als sz IX-be
	ld	d,b			; fels sz DE-be
	ld	e,c
	ld	c,100
	call	ut_div48		; eredmny osztsa 100-al
	call	ut_div48		; eredmny osztsa 100-al (sszesen 10^4)
	ld	c,10
	call	ut_div48		; eredmny osztsa  10-el (sszesen 10^5)
	ld	c,20
	call	ut_div48		; eredmny osztsa 20 ms-al
	ld	(vidtimeH),hl		; korriglt rtkek trolsa
	ld	(vidtimeL),ix
	pop	ix
;
vidtim0:ld	de,(vidtimeL)		; DE= mrt lejtszsi id 20 ms-os egysgekben
	ld	bc,00002h		; BC= 2 ms
	call	ut_mul			; a kt szm sszeszorzsa
	ex	de,hl			; eredmny als szava HL-be, fels szava DE-be
	ld	c,100
	call	ut_div32_8		; id osztsa 100-al
	push	af			; szzadmsodpercek a verembe
	ld	c,60
	call	ut_div32_8		; msodpercek osztsa 60-al
	pop	bc			; B= szzadmsodpercek
	ld	c,a			; C= msodpercek
	push	bc
	ld	c,60
	call	ut_div32_8		; percek osztsa 60-al
	pop	bc
	ld	h,l			; H= rk
	ld	l,a			; L= percek
	ld	d,c			; D= msodpercek
	ld	e,b			; E= szzadmsodpercek
	ret


;
;
;	Videmd belltsa s a kperny trlse
;	in:   C - videmd
;	out: HL - megrzdik
;
vidmod:	push	hl
	push	bc			; videmd a verembe
	ld	a,(0003Bh)		; eredeti lapozs A reg.-be
	push	af			; lapozs mentse a verembe
	ld	a,090h			; memrialapozs: U0, U1, VID, U3
	ld	(0003Bh),a		; j felhasznli lapozs belltsa
	out	(002h),a		; lapozs a porton
	ld	hl,08000h		; kperny trlse
	ld	de,08001h
	ld	a,000h			; A reg.= kitltbjt
	ld	(hl),a
	ld	bc,03BFFh
	ldir
	ld	hl,defpal		; HL a belltand alap palettra mutat
	ld	c,060h			; C= paletta-regiszterek I/O cme
	outi				; palettaregiszterek belltsa
	inc	c
	outi
	inc	c
	outi
	inc	c
	outi
	pop	af			; felhasznli lapozs vissza
	ld	(0003Bh),a
	out	(002h),a
	pop	bc
	ld	a,c
	out	(006h),a		; zemmd belltsa (+hang amplitd nullzsa)
	pop	hl
	ret

;
defpal	.db	000h, 050h, 044h, 041h	; palettaregiszterek alaprtkei
vidid	.db	"VID"
nullstr	.db	000h

;

.end
